package cd.casic.ci.process.engine.dispatcher.impl;

import cd.casic.ci.process.engine.dispatcher.BaseDispatcher;
import cd.casic.ci.process.engine.runContext.SecondStageRunContext;
import cd.casic.ci.process.process.dataObject.base.PipBaseElement;
import cd.casic.ci.process.process.dataObject.pipeline.PipPipeline;
import cd.casic.ci.process.process.dataObject.stage.PipStage;
import cd.casic.ci.process.process.dataObject.task.PipTask;

import java.util.List;
import java.util.concurrent.CountDownLatch;

public class SerialDispatcher implements BaseDispatcher {
    private SecondStageRunContext stageRunContext;
    private List<PipTask> taskList;
    private CountDownLatch latch;
    private String triggerModel;

    public SerialDispatcher(SecondStageRunContext stageRunContext, CountDownLatch latch) {
        this.stageRunContext = stageRunContext;
        PipBaseElement contextDef = stageRunContext.getContextDef();
        if (contextDef instanceof PipStage secondStage) {
            this.triggerModel = secondStage.getTriggerMode();
            this.taskList = secondStage.getTaskValues();
        }
        this.latch = latch;
    }

    @Override
    public void dispatch() {
        for (PipTask pipTask : taskList) {
            // TODO 注册taskContext，且发送消息至消息队列给work执行
        }
    }

    @Override
    public void run() {
        try {
            // TODO 检测触发方式如果需要手动触发，挂起当前stage，等待父级执行相应操作
            // TODO 看看需要内存入库还是忽略掉当前执行，进行入库（countDown放行）
//            stageRunContext.callParentChange();
            dispatch();
            latch.countDown();
        } catch (Exception e) {
//            throw new RuntimeException(e);
            // TODO 当前stage标记为失败等待父context发现并处理
        }
    }
}
